push-to-trunk.sh 13.9 KB
Newer Older
1
#!/bin/bash
2
# Copyright 2012 the V8 project authors. All rights reserved.
3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above
#       copyright notice, this list of conditions and the following
#       disclaimer in the documentation and/or other materials provided
#       with the distribution.
#     * Neither the name of Google Inc. nor the names of its
#       contributors may be used to endorse or promote products derived
#       from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


########## Global variable definitions

BRANCHNAME=prepare-push
TRUNKBRANCH=trunk-push
PERSISTFILE_BASENAME=/tmp/v8-push-to-trunk-tempfile
35
CHROME_PATH=
36 37 38

########## Function definitions

39 40
source $(dirname $BASH_SOURCE)/common-includes.sh

41 42 43 44 45 46 47 48 49 50 51
usage() {
cat << EOF
usage: $0 OPTIONS

Performs the necessary steps for a V8 push to trunk. Only works for \
git checkouts.

OPTIONS:
  -h    Show this message
  -s    Specify the step where to start work. Default: 0.
  -l    Manually specify the git commit ID of the last push to trunk.
52 53
  -c    Specify the path to your Chromium src/ directory to automate the
        V8 roll.
54 55 56 57 58
EOF
}

########## Option parsing

59
while getopts ":hs:l:c:" OPTION ; do
60 61 62 63
  case $OPTION in
    h)  usage
        exit 0
        ;;
64
    s)  START_STEP=$OPTARG
65 66 67
        ;;
    l)  LASTPUSH=$OPTARG
        ;;
68 69
    c)  CHROME_PATH=$OPTARG
        ;;
70 71 72 73 74 75 76 77 78 79
    ?)  echo "Illegal option: -$OPTARG"
        usage
        exit 1
        ;;
  esac
done


########## Regular workflow

80
initial_environment_checks
81

82 83 84 85
if [ $START_STEP -le $CURRENT_STEP ] ; then
  echo ">>> Step $CURRENT_STEP: Preparation"
  common_prepare
  delete_branch $TRUNKBRANCH
86 87
fi

88 89 90
let CURRENT_STEP+=1
if [ $START_STEP -le $CURRENT_STEP ] ; then
  echo ">>> Step $CURRENT_STEP: Create a fresh branch."
91 92 93 94
  git checkout -b $BRANCHNAME svn/bleeding_edge \
    || die "Creating branch $BRANCHNAME failed."
fi

95 96 97
let CURRENT_STEP+=1
if [ $START_STEP -le $CURRENT_STEP ] ; then
  echo ">>> Step $CURRENT_STEP: Detect commit ID of last push to trunk."
98 99 100 101 102 103 104 105 106 107 108 109 110 111 112
  [[ -n "$LASTPUSH" ]] || LASTPUSH=$(git log -1 --format=%H ChangeLog)
  LOOP=1
  while [ $LOOP -eq 1 ] ; do
    # Print assumed commit, circumventing git's pager.
    git log -1 $LASTPUSH | cat
    confirm "Is the commit printed above the last push to trunk?"
    if [ $? -eq 0 ] ; then
      LOOP=0
    else
      LASTPUSH=$(git log -1 --format=%H $LASTPUSH^ ChangeLog)
    fi
  done
  persist "LASTPUSH"
fi

113 114 115 116 117
let CURRENT_STEP+=1
if [ $START_STEP -le $CURRENT_STEP ] ; then
  echo ">>> Step $CURRENT_STEP: Prepare raw ChangeLog entry."
  # These version numbers are used again later for the trunk commit.
  read_and_persist_version
118 119 120 121 122 123 124 125 126

  DATE=$(date +%Y-%m-%d)
  persist "DATE"
  echo "$DATE: Version $MAJOR.$MINOR.$BUILD" > "$CHANGELOG_ENTRY_FILE"
  echo "" >> "$CHANGELOG_ENTRY_FILE"
  COMMITS=$(git log $LASTPUSH..HEAD --format=%H)
  for commit in $COMMITS ; do
    # Get the commit's title line.
    git log -1 $commit --format="%w(80,8,8)%s" >> "$CHANGELOG_ENTRY_FILE"
127 128 129
    # Grep for "BUG=xxxx" lines in the commit message and convert them to
    # "(issue xxxx)".
    git log -1 $commit --format="%B" \
130
        | grep "^BUG=" | grep -v "BUG=$" | grep -v "BUG=none$" \
131 132
        | sed -e 's/^/        /' \
        | sed -e 's/BUG=v8:\(.*\)$/(issue \1)/' \
133
        | sed -e 's/BUG=chromium:\(.*\)$/(Chromium issue \1)/' \
134 135
        | sed -e 's/BUG=\(.*\)$/(Chromium issue \1)/' \
        >> "$CHANGELOG_ENTRY_FILE"
136 137 138 139
    # Append the commit's author for reference.
    git log -1 $commit --format="%w(80,8,8)(%an)" >> "$CHANGELOG_ENTRY_FILE"
    echo "" >> "$CHANGELOG_ENTRY_FILE"
  done
140 141
  echo "        Performance and stability improvements on all platforms." \
    >> "$CHANGELOG_ENTRY_FILE"
142 143
fi

144 145 146
let CURRENT_STEP+=1
if [ $START_STEP -le $CURRENT_STEP ] ; then
  echo ">>> Step $CURRENT_STEP: Edit ChangeLog entry."
147 148 149 150 151 152 153
  echo -n "Please press <Return> to have your EDITOR open the ChangeLog entry, \
then edit its contents to your liking. When you're done, save the file and \
exit your EDITOR. "
  read ANSWER
  $EDITOR "$CHANGELOG_ENTRY_FILE"
  NEWCHANGELOG=$(mktemp)
  # Eliminate any trailing newlines by going through a shell variable.
154 155 156 157 158 159 160
  # Also (1) eliminate tabs, (2) fix too little and (3) too much indentation,
  # and (4) eliminate trailing whitespace.
  CHANGELOGENTRY=$(cat "$CHANGELOG_ENTRY_FILE" \
                   | sed -e 's/\t/        /g' \
                   | sed -e 's/^ \{1,7\}\([^ ]\)/        \1/g' \
                   | sed -e 's/^ \{9,80\}\([^ ]\)/        \1/g' \
                   | sed -e 's/ \+$//')
161 162 163 164 165 166 167 168
  [[ -n "$CHANGELOGENTRY" ]] || die "Empty ChangeLog entry."
  echo "$CHANGELOGENTRY" > "$NEWCHANGELOG"
  echo "" >> "$NEWCHANGELOG" # Explicitly insert two empty lines.
  echo "" >> "$NEWCHANGELOG"
  cat ChangeLog >> "$NEWCHANGELOG"
  mv "$NEWCHANGELOG" ChangeLog
fi

169 170 171
let CURRENT_STEP+=1
if [ $START_STEP -le $CURRENT_STEP ] ; then
  echo ">>> Step $CURRENT_STEP: Increment version number."
172 173 174 175 176 177 178 179 180 181 182
  restore_if_unset "BUILD"
  NEWBUILD=$(($BUILD + 1))
  confirm "Automatically increment BUILD_NUMBER? (Saying 'n' will fire up \
your EDITOR on $VERSION_FILE so you can make arbitrary changes. When \
you're done, save the file and exit your EDITOR.)"
  if [ $? -eq 0 ] ; then
    sed -e "/#define BUILD_NUMBER/s/[0-9]*$/$NEWBUILD/" \
        -i "$VERSION_FILE"
  else
    $EDITOR "$VERSION_FILE"
  fi
183
  read_and_persist_version "NEW"
184 185
fi

186 187 188 189
let CURRENT_STEP+=1
if [ $START_STEP -le $CURRENT_STEP ] ; then
  echo ">>> Step $CURRENT_STEP: Commit to local branch."
  restore_version_if_unset "NEW"
190 191 192
  PREPARE_COMMIT_MSG="Prepare push to trunk.  \
Now working on version $NEWMAJOR.$NEWMINOR.$NEWBUILD."
  persist "PREPARE_COMMIT_MSG"
193
  git commit -a -m "$PREPARE_COMMIT_MSG" \
194 195 196
    || die "'git commit -a' failed."
fi

197
upload_step
198

199 200 201 202
let CURRENT_STEP+=1
if [ $START_STEP -le $CURRENT_STEP ] ; then
  echo ">>> Step $CURRENT_STEP: Commit to the repository."
  wait_for_lgtm
203 204 205 206 207 208 209 210 211 212 213 214 215 216
  # Re-read the ChangeLog entry (to pick up possible changes).
  cat ChangeLog | awk --posix '{
    if ($0 ~ /^[0-9]{4}-[0-9]{2}-[0-9]{2}:/) {
      if (in_firstblock == 1) {
        exit 0;
      } else {
        in_firstblock = 1;
      }
    };
    print $0;
  }' > "$CHANGELOG_ENTRY_FILE"
  git cl dcommit || die "'git cl dcommit' failed, please try again."
fi

217 218 219 220
let CURRENT_STEP+=1
if [ $START_STEP -le $CURRENT_STEP ] ; then
  echo ">>> Step $CURRENT_STEP: Fetch straggler commits that sneaked in \
since this script was started."
221 222 223 224 225
  git svn fetch || die "'git svn fetch' failed."
  git checkout svn/bleeding_edge
  restore_if_unset "PREPARE_COMMIT_MSG"
  PREPARE_COMMIT_HASH=$(git log -1 --format=%H --grep="$PREPARE_COMMIT_MSG")
  persist "PREPARE_COMMIT_HASH"
226 227
fi

228 229 230
let CURRENT_STEP+=1
if [ $START_STEP -le $CURRENT_STEP ] ; then
  echo ">>> Step $CURRENT_STEP: Squash commits into one."
231 232
  # Instead of relying on "git rebase -i", we'll just create a diff, because
  # that's easier to automate.
233 234
  restore_if_unset "PREPARE_COMMIT_HASH"
  git diff svn/trunk $PREPARE_COMMIT_HASH > "$PATCH_FILE"
235 236 237 238 239 240 241 242 243 244 245 246 247 248 249 250 251 252 253 254 255 256 257 258
  # Convert the ChangeLog entry to commit message format:
  # - remove date
  # - remove indentation
  # - merge paragraphs into single long lines, keeping empty lines between them.
  restore_if_unset "DATE"
  CHANGELOGENTRY=$(cat "$CHANGELOG_ENTRY_FILE")
  echo "$CHANGELOGENTRY" \
    | sed -e "s/^$DATE: //" \
    | sed -e 's/^ *//' \
    | awk '{
        if (need_space == 1) {
          printf(" ");
        };
        printf("%s", $0);
        if ($0 ~ /^$/) {
          printf("\n\n");
          need_space = 0;
        } else {
          need_space = 1;
        }
      }' > "$COMMITMSG_FILE" || die "Commit message editing failed."
  rm -f "$CHANGELOG_ENTRY_FILE"
fi

259 260 261
let CURRENT_STEP+=1
if [ $START_STEP -le $CURRENT_STEP ] ; then
  echo ">>> Step $CURRENT_STEP: Create a new branch from trunk."
262 263 264 265
  git checkout -b $TRUNKBRANCH svn/trunk \
    || die "Checking out a new branch '$TRUNKBRANCH' failed."
fi

266 267 268
let CURRENT_STEP+=1
if [ $START_STEP -le $CURRENT_STEP ] ; then
  echo ">>> Step $CURRENT_STEP: Apply squashed changes."
269
  rm -f "$TOUCHED_FILES_FILE"
270 271
  apply_patch "$PATCH_FILE"
  rm -f "$PATCH_FILE"
272 273
fi

274 275 276 277
let CURRENT_STEP+=1
if [ $START_STEP -le $CURRENT_STEP ] ; then
  echo ">>> Step $CURRENT_STEP: Set correct version for trunk."
  restore_version_if_unset
278 279 280 281 282 283 284 285
  sed -e "/#define MAJOR_VERSION/s/[0-9]*$/$MAJOR/" \
      -e "/#define MINOR_VERSION/s/[0-9]*$/$MINOR/" \
      -e "/#define BUILD_NUMBER/s/[0-9]*$/$BUILD/" \
      -e "/#define PATCH_LEVEL/s/[0-9]*$/0/" \
      -e "/#define IS_CANDIDATE_VERSION/s/[0-9]*$/0/" \
      -i "$VERSION_FILE" || die "Patching $VERSION_FILE failed."
fi

286 287 288
let CURRENT_STEP+=1
if [ $START_STEP -le $CURRENT_STEP ] ; then
  echo ">>> Step $CURRENT_STEP: Commit to local trunk branch."
289 290 291 292 293
  git add "$VERSION_FILE"
  git commit -F "$COMMITMSG_FILE" || die "'git commit' failed."
  rm -f "$COMMITMSG_FILE"
fi

294 295 296
let CURRENT_STEP+=1
if [ $START_STEP -le $CURRENT_STEP ] ; then
  echo ">>> Step $CURRENT_STEP: Sanity check."
297 298 299 300 301 302
  confirm "Please check if your local checkout is sane: Inspect $VERSION_FILE, \
compile, run tests. Do you want to commit this new trunk revision to the \
repository?"
  [[ $? -eq 0 ]] || die "Execution canceled."
fi

303 304 305
let CURRENT_STEP+=1
if [ $START_STEP -le $CURRENT_STEP ] ; then
  echo ">>> Step $CURRENT_STEP: Commit to SVN."
306 307 308
  git svn dcommit 2>&1 | tee >(grep -E "^Committed r[0-9]+" \
                               | sed -e 's/^Committed r\([0-9]\+\)/\1/' \
                               > "$TRUNK_REVISION_FILE") \
309
    || die "'git svn dcommit' failed."
310
  TRUNK_REVISION=$(cat "$TRUNK_REVISION_FILE")
311 312 313 314 315 316 317 318 319 320 321
  # Sometimes grepping for the revision fails. No idea why. If you figure
  # out why it is flaky, please do fix it properly.
  if [ -z "$TRUNK_REVISION" ] ; then
    echo "Sorry, grepping for the SVN revision failed. Please look for it in \
the last command's output above and provide it manually (just the number, \
without the leading \"r\")."
    while [ -z "$TRUNK_REVISION" ] ; do
      echo -n "> "
      read TRUNK_REVISION
    done
  fi
322 323
  persist "TRUNK_REVISION"
  rm -f "$TRUNK_REVISION_FILE"
324 325
fi

326 327 328 329
let CURRENT_STEP+=1
if [ $START_STEP -le $CURRENT_STEP ] ; then
  echo ">>> Step $CURRENT_STEP: Tag the new revision."
  restore_version_if_unset
330 331 332 333
  git svn tag $MAJOR.$MINOR.$BUILD -m "Tagging version $MAJOR.$MINOR.$BUILD" \
    || die "'git svn tag' failed."
fi

334 335 336 337 338 339 340 341
if [ -z "$CHROME_PATH" ] ; then
  echo ">>> (asking for Chromium checkout)"
  echo -n "Do you have a \"NewGit\" Chromium checkout and want this script \
to automate creation of the roll CL? If yes, enter the path to (and including) \
the \"src\" directory here, otherwise just press <Return>: "
  read CHROME_PATH
fi

342 343 344 345 346 347 348 349 350 351 352 353
if [ -n "$CHROME_PATH" ] ; then

  let CURRENT_STEP+=1
  if [ $START_STEP -le $CURRENT_STEP ] ; then
    echo ">>> Step $CURRENT_STEP: Switch to Chromium checkout."
    V8_PATH=$(pwd)
    persist "V8_PATH"
    cd "$CHROME_PATH"
    initial_environment_checks
    # Check for a clean workdir.
    [[ -z "$(git status -s -uno)" ]] \
      || die "Workspace is not clean. Please commit or undo your changes."
354 355 356
    # Assert that the DEPS file is there.
    [[ -w "DEPS" ]] || die "DEPS file not present or not writable; \
current directory is: $(pwd)."
357
  fi
358

359 360 361 362 363 364 365 366 367 368 369 370 371 372
  let CURRENT_STEP+=1
  if [ $START_STEP -le $CURRENT_STEP ] ; then
    echo ">>> Step $CURRENT_STEP: Update the checkout and create a new branch."
    git checkout master || die "'git checkout master' failed."
    git pull || die "'git pull' failed, please try again."
    restore_if_unset "TRUNK_REVISION"
    git checkout -b "v8-roll-$TRUNK_REVISION" \
      || die "Failed to checkout a new branch."
  fi

  let CURRENT_STEP+=1
  if [ $START_STEP -le $CURRENT_STEP ] ; then
    echo ">>> Step $CURRENT_STEP: Create and upload CL."
    # Patch DEPS file.
373
    sed -r -e "/\"v8_revision\": /s/\"[0-9]+\"/\"$TRUNK_REVISION\"/" \
374 375 376 377 378 379 380
        -i DEPS
    restore_version_if_unset
    echo -n "Please enter the email address of a reviewer for the roll CL: "
    read REVIEWER
    git commit -am "Update V8 to version $MAJOR.$MINOR.$BUILD.

TBR=$REVIEWER" || die "'git commit' failed."
381
    git cl upload --send-mail \
382
      || die "'git cl upload' failed, please try again."
383
    echo "CL uploaded."
384 385 386 387 388 389 390 391 392 393 394 395 396 397 398 399 400 401 402 403 404
  fi

  let CURRENT_STEP+=1
  if [ $START_STEP -le $CURRENT_STEP ] ; then
    echo ">>> Step $CURRENT_STEP: Returning to V8 checkout."
    restore_if_unset "V8_PATH"
    cd "$V8_PATH"
  fi
fi  # if [ -n "$CHROME_PATH" ]

let CURRENT_STEP+=1
if [ $START_STEP -le $CURRENT_STEP ] ; then
  echo ">>> Step $CURRENT_STEP: Done!"
  restore_version_if_unset
  restore_if_unset "TRUNK_REVISION"
  if [ -n "$CHROME_PATH" ] ; then
    echo "Congratulations, you have successfully created the trunk revision \
$MAJOR.$MINOR.$BUILD and rolled it into Chromium. Please don't forget to \
update the v8rel spreadsheet:"
  else
    echo "Congratulations, you have successfully created the trunk revision \
405 406
$MAJOR.$MINOR.$BUILD. Please don't forget to roll this new version into \
Chromium, and to update the v8rel spreadsheet:"
407
  fi
408
  echo -e "$MAJOR.$MINOR.$BUILD\ttrunk\t$TRUNK_REVISION"
409 410
  common_cleanup
  [[ "$TRUNKBRANCH" != "$CURRENT_BRANCH" ]] && git branch -D $TRUNKBRANCH
411
fi